-#!/bin/bash
-
-USE_GLOW=true
-if ! command -v glow &> /dev/null
-then
- echo "Glow not found, markdown rendering not available."
- USE_GLOW=false
+#!/usr/bin/env sh
+# shellcheck disable=SC2016
+
+USE_GLOW=false
+USE_BAT=false
+if command -v glow >/dev/null 2>/dev/null; then
+ USE_GLOW=true
+elif command -v bat >/dev/null 2>/dev/null; then
+ USE_BAT=true
+else
+ printf "Glow or bat not found, markdown rendering not available.\n"
+ printf "Output will be raw markdown and might look weird.\n"
+ printf "Install glow or bat for easier reading & copy-paste.\n"
fi
unalias -a
"""
SKIP_OK=true
-for i in "$@" ; do
- if [[ $i == "--help" ]] || [[ $i == "-h" ]] ; then
- echo -e "$HELPSTRING"
+for i in "$@"; do
+ if [ "$i" = "--help" ] || [ "$i" = "-h" ]; then
+ printf "%b" "$HELPSTRING"
exit
- elif [[ $i == "--skip-ok" ]] ; then
+ elif [ "$i" = "--skip-ok" ]; then
SKIP_OK=true
- elif [[ $i == "--no-skip-ok" ]] ; then
+ elif [ "$i" = "--no-skip-ok" ]; then
SKIP_OK=false
- elif [[ $i == "-v" ]] ; then
+ elif [ "$i" = "-v" ]; then
SKIP_OK=false
fi
done
-ERR=0
-WARN=1
-INFO=2
-SUCS=3
-HELP=4
+if [ -z "${XDG_DATA_HOME}" ]; then
+ printf '\e[1;36m%s\e[1;0m\n' "The \$XDG_DATA_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf '\e[1;36m ⤷ \e[1mThe recommended value is: \e[1;3m$HOME/.local/share\e[1;0m\n'
+fi
+if [ -z "${XDG_CONFIG_HOME}" ]; then
+ printf '\e[1;36m%s\e[1;0m\n' "The \$XDG_CONFIG_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf '\e[1;36m ⤷ \e[1mThe recommended value is: \e[1;3m$HOME/.config\e[1;0m\n'
+fi
+if [ -z "${XDG_STATE_HOME}" ]; then
+ printf '\e[1;36m%s\e[1;0m\n' "The \$XDG_STATE_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf '\e[1;36m ⤷ \e[1mThe recommended value is: \e[1;3m$HOME/.local/state\e[1;0m\n'
+fi
+if [ -z "${XDG_CACHE_HOME}" ]; then
+ printf '\e[1;36m%s\e[1;0m\n' "The \$XDG_CACHE_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf '\e[1;36m ⤷ \e[1mThe recommended value is: \e[1;3m$HOME/.cache\e[1;0m\n'
+fi
+if [ -z "${XDG_RUNTIME_DIR}" ]; then
+ printf '\e[1;36m%s\e[1;0m\n' "The \$XDG_RUNTIME_DIR environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf '\e[1;36m ⤷ \e[1mThe recommended value is: \e[1;3m/run/user/$UID\e[1;0m\n'
+fi
+
+if ! command -v jq >/dev/null 2>/dev/null; then
+ printf "jq is needed to run this script, but it wasn't found. Please install it to be able to use this script."
+ exit
+fi
+
+printf "\n"
-# Function to expand enviornment variables in string
+# Function to expand environment variables in string
# https://stackoverflow.com/a/20316582/11110290
apply_shell_expansion() {
- declare data="$1"
- declare delimiter="__apply_shell_expansion_delimiter__"
- declare command="cat <<$delimiter"$'\n'"$data"$'\n'"$delimiter"
+ data="$1"
+ delimiter="__apply_shell_expansion_delimiter__"
+ command=$(printf "cat <<%s\n%s\n%s" "$delimiter" "$data" "$delimiter")
eval "$command"
}
fi
}
-
# Function to handle the formatting of output
log() {
MODE="$1"
case "$MODE" in
- ERR)
- printf "[\e[1;31m$NAME\e[1;0m]: \e[1;3m$FILENAME\e[1;0m\n"
- ;;
-
- WARN)
- printf "[\e[1;33m$NAME\e[1;0m]: \e[1;3m$FILENAME\e[1;0m\n"
- ;;
-
- INFO)
- printf "[\e[1;36m$NAME\e[1;0m]: \e[1;3m$FILENAME\e[1;0m\n"
- ;;
-
- SUCS)
- if [ "$SKIP_OK" = false ]; then
- printf "[\e[1;32m$NAME\e[1;0m]: \e[1;3m$FILENAME\e[1;0m\n"
- fi
- ;;
-
- HELP)
- if $USE_GLOW; then
- echo "$HELP" | glow -
- else
- echo "$HELP"
- fi
- ;;
+ ERR)
+ printf '[\e[1;31m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ ;;
+
+ WARN)
+ printf '[\e[1;33m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ ;;
+
+ INFO)
+ printf '[\e[1;36m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ ;;
+
+ SUCS)
+ [ "$SKIP_OK" = false ] &&
+ printf '[\e[1;32m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ ;;
+
+ HELP)
+ if $USE_GLOW; then
+ printf "%s" "$HELP" | glow -
+ elif $USE_BAT; then
+ printf "%s" "$HELP" | bat -pp -f --language markdown
+ else
+ printf "%s" "$HELP"
+ fi
+ ;;
esac
}
INPUT="$1"
NAME="$2"
- FILENAME=$(echo -E "$INPUT" | jq -r .path)
- MOVABLE=$(echo -E "$INPUT" | jq -r .movable)
- HELP=$(echo -E "$INPUT" | jq -r .help)
+ FILENAME=$(printf "%s" "$INPUT" | jq -r .path)
+ MOVABLE=$(printf "%s" "$INPUT" | jq -r .movable)
+ HELP=$(printf "%s" "$INPUT" | jq -r .help)
check_not_exists_file "$FILENAME"
case $? in
- 0)
- log SUCS "$NAME" "$FILENAME" "$HELP"
- ;;
-
- 1 | 2)
- if "$MOVABLE"; then
- log ERR "$NAME" "$FILENAME" "$HELP"
- else
- log WARN "$NAME" "$FILENAME" "$HELP"
- fi
- if ! [ -z "$HELP" ]; then
- log HELP "$NAME" "$FILENAME" "$HELP"
- else
- log HELP "$NAME" "$FILENAME" "_No help available._"
- fi
- ;;
+ 0)
+ log SUCS "$NAME" "$FILENAME" "$HELP"
+ ;;
+
+ 1 | 2)
+ if "$MOVABLE"; then
+ log ERR "$NAME" "$FILENAME" "$HELP"
+ else
+ log WARN "$NAME" "$FILENAME" "$HELP"
+ fi
+ if [ "$HELP" ]; then
+ log HELP "$NAME" "$FILENAME" "$HELP"
+ else
+ log HELP "$NAME" "$FILENAME" "_No help available._"
+ fi
+ ;;
esac
}
check_program() {
INPUT=$1
- NAME=$(echo "$INPUT" | jq -r .name)
-
+ NAME=$(printf "%s" "$INPUT" | jq -r .name)
while IFS= read -r file; do
check_file "$file" "$NAME"
- done <<< "$(echo "$INPUT" | jq -rc '.files[]')"
+ done <<EOF
+$(echo "$INPUT" | jq -rc '.files[]')
+EOF
}
# Loops over all files in the programs/ directory and calls check_program
enumerate_programs() {
- for prog_filename in ./programs/*; do
- check_program "$(cat $prog_filename)"
+ printf "\e[1;3mStarting to check your \e[1;36m\$HOME.\e[1;0m\n"
+ printf "\n"
+ for prog_filename in "${0%/*}"/programs/*; do
+ check_program "$(cat "$prog_filename")"
done
+ printf "\e[1;3mDone checking your \e[1;36m\$HOME.\e[1;0m\n"
+ printf "\n"
+ printf "\e[3mIf you have files in your \e[1;36m\$HOME\e[1;0m that shouldn't be there, but weren't recognised by xdg-ninja, please consider creating a configuration file for it and opening a pull request on github.\e[1;0m\n"
+ printf "\n"
}
enumerate_programs